/**
 * This file Copyright (c) 2011 Magnolia International
 * Ltd.  (http://www.magnolia-cms.com). All rights reserved.
 *
 *
 * This file is dual-licensed under both the Magnolia
 * Network Agreement and the GNU General Public License.
 * You may elect to use one or the other of these licenses.
 *
 * This file is distributed in the hope that it will be
 * useful, but AS-IS and WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE, TITLE, or NONINFRINGEMENT.
 * Redistribution, except as permitted by whichever of the GPL
 * or MNA you select, is prohibited.
 *
 * 1. For the GPL license (GPL), you can redistribute and/or
 * modify this file under the terms of the GNU General
 * Public License, Version 3, as published by the Free Software
 * Foundation.  You should have received a copy of the GNU
 * General Public License, Version 3 along with this program;
 * if not, write to the Free Software Foundation, Inc., 51
 * Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * 2. For the Magnolia Network Agreement (MNA), this file
 * and the accompanying materials are made available under the
 * terms of the MNA which accompanies this distribution, and
 * is available at http://www.magnolia-cms.com/mna.html
 *
 * Any modifications to this file must keep this entire header
 * intact.
 *
 */
package info.magnolia.ui.widget.editor.gwt.client.widget.overlay;


import com.google.gwt.dom.client.Document;
import com.google.gwt.dom.client.Element;
import com.google.gwt.dom.client.Style;
import com.google.gwt.user.client.ui.FlowPanel;
import info.magnolia.ui.widget.editor.gwt.client.dom.MgnlElement;


/**
 * Base class for overlay widgets.
 */
public class AbstractOverlay extends FlowPanel {

    protected String label;
    protected int level = 1;
    private double top;
    public AbstractOverlay(MgnlElement element) {

        this.label = element.getAttribute("label");

        for (MgnlElement parent = element.getParent(); parent != null; parent = parent.getParent()) {
            this.level++;
        }


        this.setStyleName("mgnlEditorOverlay");

        this.getElement().getStyle().setPosition(Style.Position.ABSOLUTE);
        this.getElement().getStyle().setZIndex(level);

    }

    public void attach() {
        Element body = Document.get().getBody();
        body.appendChild(this.getElement());
        onAttach();
    }

    public void toggleVisible() {
        setVisible(!isVisible());
    }

    public void setTop(double top) {
        this.top = top;
        this.getElement().getStyle().setTop(top, Style.Unit.PX);
    }
    public double getTop() {
        return top;
    }
    public void setLeft(double left) {
        this.getElement().getStyle().setLeft(left, Style.Unit.PX);
    }

    public void setWidth(double width) {
        this.getElement().getStyle().setWidth(width, Style.Unit.PX);
    }

    public void setHeight(double height) {
        this.getElement().getStyle().setHeight(height, Style.Unit.PX);
    }


}